/*
Copyright (c) 2000, The JAP-Team 
All rights reserved.
Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

	- Redistributions of source code must retain the above copyright notice, 
	  this list of conditions and the following disclaimer.

	- Redistributions in binary form must reproduce the above copyright notice, 
	  this list of conditions and the following disclaimer in the documentation and/or 
		other materials provided with the distribution.

	- Neither the name of the University of Technology Dresden, Germany nor the names of its contributors 
	  may be used to endorse or promote products derived from this software without specific 
		prior written permission. 

	
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY EXPRESS 
OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, 
OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY 
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE
*/
#ifdef WITH_CONTROL_CHANNELS_TEST
#include "CASyncControlChannel.hpp"

/** A Control channel for testing if the control channels are working. 
	* This channel simply reflects every message it receives.
	*/
class CAControlChannelTest :
	public CASyncControlChannel
{
public:
	CAControlChannelTest(void);
	virtual ~CAControlChannelTest(void);

	/** Reflects the incoming message back to the sender*/
	SINT32 processXMLMessage(DOM_Document& doc)
	{
		if(doc==NULL)
			return E_UNKNOWN;
		DOM_Element elemRoot=doc.getDocumentElement();
		if(elemRoot==NULL)
			return E_UNKNOWN;
		//Hm, I am to stupid to do it better...
		DOM_Document* myDoc=new DOM_Document;
		*myDoc=DOM_Document::createDocument();
		myDoc->appendChild(myDoc->importNode(elemRoot,true));
		return sendXMLMessage(*myDoc);
	}
};
#endif
